## xtrkcad 5.3.0GA

=== CMakeLists.txt ===
# Main CMake file for XTrackCAD

cmake_minimum_required(VERSION 3.20.0)
project(XTrkCAD)

cmake_policy(SET CMP0076 NEW)
cmake_policy(SET CMP0079 NEW)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
# additional CMake modules can be found here
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

# Include CMake defaults
include(CMakeDefaults)

include(CheckIncludeFiles)

include(ProgramVersion.cmake)
include(PlatformSettings.cmake)

enable_testing()

# Find all dependencies
# 
# Additional libraries

find_package(Libzip)
find_package(Zlib)

# Optionally enable SVG export
find_package(MiniXML)
if(MiniXML_FOUND)
    set(XTRKCAD_CREATE_SVG 1)
	message( STATUS "MiniXML found: SVG export is enabled")
else()
	message( STATUS "MiniXML not found: no SVG export")
endif()

# Find unit testing framework
find_package(CMocka)
if(CMOCKA_FOUND)
	include_directories(${CMOCKA_INCLUDE_DIR})
 	set(LIBS ${LIBS} ${CMOCKA_LIBRARIES})
 	option(XTRKCAD_TESTING "Build unittests" ON)
endif()

# Tools
# Find document conversion tool
find_package(Pandoc)

# For handling and creation of bitmaps the FreeImage library is required
find_package(FreeImage REQUIRED)

# check for GTK+ 2.0
if(UNIX)
    pkg_check_modules(GTK REQUIRED "gtk+-2.0")
	set(XTRKCAD_USE_GTK_DEFAULT ON)
endif(UNIX)

if(WIN32 AND NOT XTRKCAD_USE_GTK)
	# use the Windows HTMLHelp tool
	find_package(HTMLHelp REQUIRED)
endif(WIN32 AND NOT XTRKCAD_USE_GTK)

# 
# Configure options
#

option(XTRKCAD_USE_GTK "Use GTK for the graphical user interface back-end" ${XTRKCAD_USE_GTK_DEFAULT})
option(XTRKCAD_USE_GETTEXT "Use gettext for internationalization" ${XTRKCAD_USE_GETTEXT_DEFAULT})
option(XTRKCAD_USE_DOXYGEN "Generate internals documentation using doxygen" OFF)

if(UNIX AND NOT APPLE)
    option(XTRKCAD_USE_BROWSER "Show help in default browser" ${XTRKCAD_USE_BROWSER_DEFAULT})
endif()

if(APPLE)
	option(XTRKCAD_USE_APPLEHELP "Show help in Apple Help" ${XTRKCAD_USE_APPLEHELP_DEFAULT})
	option(XTRKCAD_USE_BROWSER "Show help in default browser" ${XTRKCAD_USE_BROWSER_DEFAULT})
	option(XTRKCAD_USE_PACKAGEMAKER "Generate an OSX PackageMaker package for distribution." OFF)
endif()

# Hide the advanced stuff ...
mark_as_advanced(CMAKE_BACKWARDS_COMPATIBILITY)
mark_as_advanced(CMAKE_EXECUTABLE_FORMAT)
mark_as_advanced(CMAKE_OSX_ARCHITECTURES)
mark_as_advanced(CMAKE_OSX_SYSROOT)
mark_as_advanced(CMAKE_USE_CHRPATH)
mark_as_advanced(EXECUTABLE_OUTPUT_PATH)
mark_as_advanced(LIBRARY_OUTPUT_PATH)

# Test for headers and libraries for portability ...
# check_include_files (malloc.h HAVE_MALLOC_H)
# if(HAVE_MALLOC_H)
#   add_definitions(-DHAVE_MALLOC_H)
# endif()

#packaging related stuff

if(XTRKCAD_USE_PACKAGEMAKER)
	if(NOT CMAKE_INSTALL_PREFIX STREQUAL "/usr")
		message(SEND_ERROR "XTRKCAD_USE_PACKAGEMAKER requires CMAKE_INSTALL_PREFIX set to /usr.")
	endif()
endif()

#
# configure installation directories
if(WIN32)
	set( CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX} ${XTRKCAD_VERSION}" )
endif()

set(XTRKCAD_BIN_INSTALL_DIR "bin")
set(XTRKCAD_LOCALE_INSTALL_DIR "share/locale")
set(XTRKCAD_PACKAGE "xtrkcad")
set(XTRKCAD_BETA "")
if(UNIX AND NOT APPLE)
	if(XTRKCAD_VERSION_MODIFIER MATCHES "^Beta")
		set(XTRKCAD_BETA "-beta")
	endif()
endif()
set(XTRKCAD_SHARE_INSTALL_DIR "share/xtrkcad${XTRKCAD_BETA}")

# Enable use of a configuration file ...
add_definitions(-DXTRKCAD_CMAKE_BUILD)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/xtrkcad-config.h.in ${CMAKE_CURRENT_BINARY_DIR}/xtrkcad-config.h)

# find the config.h include file
include_directories(
	${CMAKE_CURRENT_BINARY_DIR}
)

#
# I18N related dependencies

if(XTRKCAD_USE_GETTEXT)
	#
	# Find the GnuWin32 installation directory, the gettext include should be located in subdir include
	#
	if(WIN32)
		if(MSVC)
			# use supplied gettext library for Visual Studio
			message( STATUS "Use simple_gettext module included with XTrackCAD" )
			add_definitions(-DUSE_SIMPLE_GETTEXT )
		else()
			# for mingw & co. find libintl.h and use it
			find_path ( INTL_PATH libintl.h )
			if(INTL_PATH)
				message( STATUS "Use installed gettext module" )
				include_directories(${INTL_PATH})
			endif()
		endif()
	endif()
	if(APPLE)
		find_path ( INTL_PATH libintl.h )
		if(INTL_PATH)
			message( STATUS "Use installed gettext module" )
			include_directories(${INTL_PATH})
		endif()
	endif()
endif()

# Setup the rest of the build ...
add_subdirectory(app)
add_subdirectory(distribution)
add_subdirectory(docs)

=== distribution/CMakeLists.txt ===
# Setup global packaging parameters ...
SET(CPACK_PACKAGE_DESCRIPTION "XTrackCad is a CAD program for designing model railroad layouts.")
SET(CPACK_PACKAGE_EXECUTABLES "xtrkcad;XTrkCAD ${XTRKCAD_VERSION}")
IF(WIN32)
	# Add suffix
	SET(CPACK_PACKAGE_FILE_NAME "xtrkcad-setup-${XTRKCAD_VERSION}-${XTRKCAD_ARCH_SUBDIR}")
ELSE(WIN32)
	SET(CPACK_PACKAGE_FILE_NAME "xtrkcad-setup-${XTRKCAD_VERSION}")
ENDIF(WIN32)
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "XTrkCAD ${XTRKCAD_VERSION}")
SET(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "XTrkCAD ${XTRKCAD_VERSION}")
SET(CPACK_PACKAGE_NAME "xtrkcad")
SET(CPACK_PACKAGE_VENDOR "XTrackCAD Project")
SET(CPACK_PACKAGE_VERSION ${XTRKCAD_VERSION})
SET(CPACK_PACKAGE_VERSION_MAJOR ${XTRKCAD_MAJOR_VERSION})
SET(CPACK_PACKAGE_VERSION_MINOR ${XTRKCAD_MINOR_VERSION})
SET(CPACK_PACKAGE_VERSION_PATCH ${XTRKCAD_RELEASE_VERSION})
SET(CPACK_RESOURCE_FILE_LICENSE "${XTrkCAD_SOURCE_DIR}/app/COPYING")
SET(CPACK_SOURCE_GENERATOR "ZIP;TGZ")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "xtrkcad-source-${XTRKCAD_VERSION}")

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/downloadpage.wiki.in ${CMAKE_BINARY_DIR}/downloadpage.wiki)

# Setup platform-specific packaging ...
IF(APPLE)
	ADD_SUBDIRECTORY(osx)
ENDIF(APPLE)

IF(UNIX AND NOT APPLE)
	ADD_SUBDIRECTORY(posix)
ENDIF(UNIX AND NOT APPLE)

IF(WIN32)
	ADD_SUBDIRECTORY(win32)
ENDIF(WIN32)

=== docs/CMakeLists.txt ===
if(XTRKCAD_USE_DOXYGEN)
  add_subdirectory(doxygen)
endif(XTRKCAD_USE_DOXYGEN)

=== app/bin/CMakeLists.txt ===
project(xtrkcad-lib)

include( CheckSymbolExists )
#
# Create line symbols for turnouts from src definitions 
#
#	1. Build converter cnvdsgn
#   2. define target "lines" for all symols
#	3. create .lin-files using converter
#	4. add individual .lin-files as dependency to "lines"
#

# build GA or Beta executable
set( XTRKCAD_BIN "xtrkcad${XTRKCAD_BETA}" )

add_subdirectory(bitmaps)

add_executable(cnvdsgn cnvdsgn.c utility.c)

target_link_libraries(cnvdsgn xtrkcad-wlib)

if(NOT WIN32)
	target_link_libraries(cnvdsgn m)
endif()

add_custom_target(lines
	DEPENDS cnvdsgn
)

#
# macro to copy DLLs into build directory
# eases debugging on Windows
#
if(WIN32)
    macro(COPYDLLTOBUILD dllname)
        add_custom_command(
            TARGET xtrkcad POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
            ${dllname}
            ${CMAKE_CURRENT_BINARY_DIR}
        )
    endmacro(COPYDLLTOBUILD)
endif()


#
# macro creates lin files and adds the result as dependency
#

macro(GENERATE_LIN lin_name)
	add_custom_command(
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${lin_name}.lin
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${lin_name}.src
		COMMAND cnvdsgn < ${CMAKE_CURRENT_SOURCE_DIR}/${lin_name}.src > ${CMAKE_CURRENT_BINARY_DIR}/${lin_name}.lin
	)
	
	target_sources(lines 
		PRIVATE
			${CMAKE_CURRENT_BINARY_DIR}/${lin_name}.lin
	)
endmacro(GENERATE_LIN)

GENERATE_LIN(to3way)
GENERATE_LIN(tocrv)
GENERATE_LIN(tocrvsct)
GENERATE_LIN(todcross)
GENERATE_LIN(todslip)
GENERATE_LIN(tolcross)
GENERATE_LIN(torcross)
GENERATE_LIN(toreg)
GENERATE_LIN(tosslip)
GENERATE_LIN(tostrsct)
GENERATE_LIN(towye)
GENERATE_LIN(toxing)
GENERATE_LIN(tocornu)
GENERATE_LIN(tocornuwye)
GENERATE_LIN(tocornu3way)

# put these targets into the folder LineSymbols
set_target_properties(lines cnvdsgn PROPERTIES FOLDER LineSymbols)

add_library(xtrkcad-lib "")

target_sources(xtrkcad-lib
	PRIVATE
    appdefaults.c
    archive.c
    archive.h
    cbezier.c
    cbezier.h
    cblock.c
    ccornu.c
    ccornu.h
    ccurve.c
    ccurve.h
    ccontrol.c
    cdraw.c
    celev.c
    cgroup.c
    chndldto.c
    chotbar.c
    cjoin.c
    cjoin.h
    cmisc.c
    cmodify.c
    cnote.c
	command.c
	command.h
    common.h
    common-ui.h
    compound.c
    compound.h
    cparalle.c
    cprint.c
    cprofile.c
    cpull.c
    cruler.c
    cselect.c
    cselect.h
    csensor.c
    csnap.c
    csplit.c
    csignal.c
    cstraigh.c
    cstraigh.h
    cstruct.c
    cswitchmotor.c
    ctext.c
    ctodesgn.c
    ctrain.c
    ctrain.h
    cturnout.c
    cturntbl.c
    cundo.c
    cundo.h
    custom.c
    custom.h
    dbench.c
    dbitmap.c
    dcar.c
    dcmpnd.c
    dcustmgm.c
    dcontmgm.c
    dease.c
    denum.c
    directory.c
    directory.h
    dlayer.c
	dlayer.h
    doption.c
    dpricels.c
    dprmfile.c
    draw.c
    draw.h
    drawgeom.c
    drawgeom.h
    dxfformat.c
    dxfformat.h
    dxfoutput.c
    elev.c
    file2uri.c
    file2uri.h
    fileio.c
    fileio.h
    filenoteui.c
    i18n.c
    layout.c
    layout.h
    levenshtein.c
    linknoteui.c
    lprintf.c
    macro.c
    manifest.c
    manifest.h
	menu.h
	menu.c
    misc.c
    misc.h
    note.h
    param.c
    param.h
    paramfile.c
    paramfilelist.c
    paramfilesearch_ui.c
    partcatalog.c
    paths.c
    paths.h
    problemrep.c
    problemrepui.c
	scale.c
	scale.h
    shortentext.c
    shortentext.h
    shrtpath.c
    shrtpath.h
    smalldlg.c
    smalldlg.h
    stringxtc.c
    tbezier.c
    tbezier.h
    tcornu.c
    tcornu.h
    tcurve.c
    tease.c
    textnoteui.c
    track.c
    track.h
    trackx.h
    trkendpt.c
    trkendpt.h
    trkendptx.h
    trknote.c
	trkseg.h
    trkseg.c
    tstraigh.c
    turnout.c
    uthash.h
    utility.c
    utility.h
    validator.c
    validator.h
    include/dirent.h
    include/levenshtein.h
    include/paramfile.h
    include/paramfilelist.h
    include/partcatalog.h
    include/problemrep.h
    include/stringxtc.h
    include/utlist.h
)

# add UTF-8 conversion utilities on Windows

if(WIN32)
	target_sources(xtrkcad-lib
		PRIVATE
			utf8convert.c
			include/utf8convert.h			
	)
endif()

# This ensures that messages.h has been generated before we build xtrkcad-lib
add_dependencies(xtrkcad-lib 
    msgfiles
	lines
    genbitmaps
)


target_include_directories(xtrkcad-lib 
    PUBLIC
	${messagefile_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_link_libraries(xtrkcad-lib
    PRIVATE
    cJSON
	dynstring
	xtrkcad-cornu
	xtrkcad-wlib
)

if(UNIX AND NOT APPLE)
	target_link_libraries(xtrkcad-lib PRIVATE ${LIBZIP_LIBRARY} ${LIBZIP_LIBRARIES} ${ZLIB_LIBRARY})
else()
    target_link_libraries(xtrkcad-lib 
        PRIVATE 
        Libzip::Libzip 
        FreeImage::FreeImage 
        Zlib::Zlib)
endif()

#
# Start building the main program itself
#
add_executable(${XTRKCAD_BIN} WIN32 "" )

# if SVG export is built and source files and dependency on MiniXML

if(XTRKCAD_CREATE_SVG)
	target_sources(xtrkcad-lib
		PRIVATE
			svgformat.c
			svgoutput.c
	)

	if(WIN32)
        target_link_libraries(xtrkcad-lib 
            PRIVATE 
            MiniXML::mxml
        )
	endif()
	if(UNIX)
		if (APPLE OR NOT ${MINIXML_STATIC_LIBRARY})
            target_link_libraries(xtrkcad-lib 
                PRIVATE 
                MiniXML::mxml
            )       
        else()
			target_link_libraries(xtrkcad ${MINIXML_STATIC_LIBRARY})
			target_link_libraries(xtrkcad "pthread")
		endif()
	endif()
endif()

target_sources(${XTRKCAD_BIN}
	PRIVATE
		misc.c
        ${messagefile_BINARY_DIR}/bllnhlp.c
		xtrkcad.rc
)
add_dependencies(${XTRKCAD_BIN}
    balloonhelp
    msgfiles
    genbitmaps)
    
target_include_directories(${XTRKCAD_BIN}
    PRIVATE
	${messagefile_BINARY_DIR}    
)

target_link_libraries(${XTRKCAD_BIN}
    PRIVATE
		xtrkcad-wlib
		xtrkcad-lib
)

#
# Create mkturnout utility
#
add_executable(mkturnout
    ctodesgn.c
	utility.c
    trkendpt.c
)
set_target_properties(mkturnout PROPERTIES COMPILE_FLAGS -DMKTURNOUT)
set_target_properties(mkturnout PROPERTIES FOLDER "Param Files" )

target_include_directories(mkturnout
    PRIVATE
	${messagefile_BINARY_DIR}
)

target_link_libraries(mkturnout
    PRIVATE
    xtrkcad-wlib 
)

add_dependencies(mkturnout
    msgfiles
    lines
)

if(NOT WIN32)
	target_link_libraries(mkturnout 
        PRIVATE
        m
    )
	target_link_libraries(${XTRKCAD_BIN}
        PRIVATE
        m
    )

	# Link libintl for systems where it is a separate library
	find_library( INTL_LIBRARY intl )
	if(INTL_LIBRARY)
		target_link_libraries( mkturnout
            PRIVATE 
            ${INTL_LIBRARY}
        )
	endif()
else()
	# copy dlls into the build dir for easier debugging
    COPYDLLTOBUILD(${FREEIMAGE_SHAREDLIB})
#    COPYDLLTOBUILD(${LIBZIP_SHAREDLIB})
#    COPYDLLTOBUILD(${ZLIB_SHAREDLIB})
    set(ENV{path} "${CMAKE_CURRENT_BINARY_DIR};$ENV{PATH}")
	# add dll to install package
	install(
	    FILES ${LIBZIP_SHAREDLIB}
	    DESTINATION ${XTRKCAD_BIN_INSTALL_DIR}
	)
    install(
        FILES ${ZLIB_SHAREDLIB}
	    DESTINATION ${XTRKCAD_BIN_INSTALL_DIR}
	)

    # Copy program PDB file
    install(
        FILES $<TARGET_PDB_FILE:xtrkcad>
	    DESTINATION ${XTRKCAD_BIN_INSTALL_DIR} 
        OPTIONAL
	)
endif()

# for testing only, should be IF(APPLE) ...
if(APPLE)
	add_executable( helphelper helphelper.c )
	find_library(COREFOUNDATION_LIBRARY CoreFoundation)
	find_library(CARBON_LIBRARY Carbon)
	target_link_libraries(helphelper ${COREFOUNDATION_LIBRARY} ${CARBON_LIBRARY})
	install(
		TARGETS helphelper
		RUNTIME DESTINATION ${XTRKCAD_BIN_INSTALL_DIR}
		)
endif()

install(
	TARGETS ${XTRKCAD_BIN}
	RUNTIME DESTINATION ${XTRKCAD_BIN_INSTALL_DIR}
)

if(XTRKCAD_TESTING AND CMOCKA_FOUND)
	add_subdirectory( unittest )
endif()

=== app/cornu/CMakeLists.txt ===
project(cornu)
	
add_library(xtrkcad-cornu "")

target_sources(xtrkcad-cornu
	PRIVATE
		bezctx.c
		bezctx_xtrkcad.c
		spiroentrypoints.c
		spiro.c
		bezctx.h
		bezctx_intf.h
		zmisc.h	
)

target_sources(xtrkcad-cornu
	PUBLIC
		bezctx_xtrkcad.h
		spiroentrypoints.h
		spiro.h
)

target_link_libraries(xtrkcad-cornu
	PRIVATE
		xtrkcad-wlib
		xtrkcad-lib
)

target_include_directories(xtrkcad-cornu PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")

=== app/doc/CMakeLists.txt ===
project(doc)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/intro.but.in ${CMAKE_CURRENT_BINARY_DIR}/intro.but)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/hhc.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/hhc.cmake @ONLY)

#
# Create directory for the html stage

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html)

add_custom_target(helpsystem)
set_target_properties(
   helpsystem
   PROPERTIES FOLDER HelpDocs
)

target_sources(helpsystem
	PRIVATE
	${CMAKE_CURRENT_BINARY_DIR}/intro.but
	${CMAKE_CURRENT_SOURCE_DIR}/addm.but
	${CMAKE_CURRENT_SOURCE_DIR}/changem.but
	${CMAKE_CURRENT_SOURCE_DIR}/drawm.but
	${CMAKE_CURRENT_SOURCE_DIR}/editm.but
	${CMAKE_CURRENT_SOURCE_DIR}/filem.but
	${CMAKE_CURRENT_SOURCE_DIR}/helpm.but
	${CMAKE_CURRENT_SOURCE_DIR}/hotbar.but
	${CMAKE_CURRENT_SOURCE_DIR}/macrom.but
	${CMAKE_CURRENT_SOURCE_DIR}/managem.but
	${CMAKE_CURRENT_SOURCE_DIR}/optionm.but
	${CMAKE_CURRENT_SOURCE_DIR}/statusbar.but
	${CMAKE_CURRENT_SOURCE_DIR}/view_winm.but
	${CMAKE_CURRENT_SOURCE_DIR}/navigation.but
	${CMAKE_CURRENT_SOURCE_DIR}/appendix.but
	${messagefile_BINARY_DIR}/messages.but
	${CMAKE_CURRENT_SOURCE_DIR}/upgrade.but
	${CMAKE_CURRENT_SOURCE_DIR}/warranty.but
)

#
# messages.but is generated in a different directory scope, CMake must not check for existance
set_source_files_properties(${messagefile_BINARY_DIR}/messages.but
	PROPERTIES 
	GENERATED True)

# Add a custom command for cleaning the HTML staging directory
add_custom_target(clean-html
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/clean-html.cmake
)

# If we're using the GTK back-end, just generate "vanilla" HTML help files for use with gtkhtml
if(XTRKCAD_USE_GTK)

	if (APPLE)
		target_sources(helpsystem
			PRIVATE 
			${CMAKE_CURRENT_SOURCE_DIR}/osxconf.but)
	else()
		target_sources(helpsystem 
			PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/linconf.but)
	endif()

	get_target_property(halibut_sources helpsystem SOURCES)

	add_custom_command(
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
		DEPENDS halibut ${halibut_sources}
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
		COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/clean-html.cmake
		COMMAND halibut ${halibut_sources}
		)

	add_custom_target(help-html ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/html/index.html msgfiles)

	install(
		DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
		DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
		)

	install(
		DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/png.d
		DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}/html
		)

	install(
		FILES xtrkcad_lin.css
		DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}/html
        )
# Copy the help files to the Help bundle if Apple
	if (APPLE)
        add_custom_command(
        	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/html/XTrackCAD.helpindex
        	DEPENDS help-html ${halibut_sources}
        	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
        	COMMAND hiutil -Cf XTrackCAD.helpindex -gva -e "IndexPage.html" -e "toc.html" ${CMAKE_CURRENT_BINARY_DIR}/html
        )

        add_custom_target(help-index ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/html/XTrackCAD.helpindex)

        install(
            DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
            DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}/XTrackCAD.help/Contents/Resources/en.lproj
        )
        install(
            DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/png.d
            DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}/XTrackCAD.help/Contents/Resources/en.lproj
        )
	    install(
	        FILES xtrkcad_osx.css
		    DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}/XTrackCAD.help/Contents/Resources/en.lproj/sty
	)
    endif()

# Otherwise, we're using the Win32 back-end, so generate a compiled HTML help file
else()
    find_package(HTMLHelp)

    if("${HTML_HELP_COMPILER}" STRGREATER "")
        target_sources(helpsystem
                    PRIVATE
                    ${CMAKE_CURRENT_SOURCE_DIR}/chmconf.but
        )
    	file(GLOB IMAGE_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/png.d/*)

		#
		# Use the Microsoft HTML Help Workshop to create a chm file
		# 
		# Clean the working directory
		# Copy the image files and the CSS
		# Create the sources for the Help Workshop using halibut
		# Build the chm file
		# Add the chm file to the installation 

		add_custom_target(help-chm ALL DEPENDS ${halibut_sources})
		set_target_properties(
			help-chm
			PROPERTIES FOLDER HelpDocs
		)
		get_target_property(halibut_sources helpsystem SOURCES)
		
		# hhc exits with non-zero code even on success
		# workaround is to create an external cmake script that
		# invokes hhc and handle its specific exit code
		configure_file("${CMAKE_CURRENT_SOURCE_DIR}/hhc.cmake.in"
					   "${CMAKE_CURRENT_BINARY_DIR}/hhc.cmake"
						@ONLY)	

		add_custom_command(
			TARGET help-chm
			DEPENDS halibut helpsystem ${IMAGE_SOURCES} ${CMAKE_CURRENT_SOURCE_DIR}/xtrkcad_win.css
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
			COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/clean-html.cmake
			COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/png.d ${CMAKE_CURRENT_BINARY_DIR}/html/png.d
			COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/xtrkcad_win.css ${CMAKE_CURRENT_BINARY_DIR}/html
			COMMAND halibut ${halibut_sources} 
			COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/hhc.cmake
		)

		install(
			FILES ${CMAKE_CURRENT_BINARY_DIR}/html/xtrkcad.chm
			DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
		)
	else()
		message(STATUS "HTML Help Workshop not found! CHM Help will not be created.")	
	endif()
endif()

=== app/help/CMakeLists.txt ===
project(messagefile)

#
# genhelp is used in ..\bin to generate the tooltip texts

add_executable(genhelp "")
target_sources(genhelp 
	PRIVATE
	genhelp.c)

target_link_libraries(genhelp 
	PUBLIC	
	cJSON
)

#
# interpreter for message source file

add_executable(genmessages "")

target_sources(genmessages PUBLIC
	genmessages.c
)

set_source_files_properties(
	genhelp.json messages.in xtrkcad.tip 
	PROPERTIES HEADER_FILE_ONLY TRUE
)

#
# Generate message include file and the input file for the help system

if(XTRKCAD_USE_GETTEXT)
	set(GENHELP_OPTS "-bhi" )
	set(GENMESSAGES_OPTS "-i18n")
else()
	set(GENHELP_OPTS "-bh" )
	set(GENMESSAGES_OPTS "")
endif()

add_custom_command(
       OUTPUT bllnhlp.c
       DEPENDS genhelp genhelp.json
       COMMAND genhelp ${GENHELP_OPTS} ${CMAKE_CURRENT_SOURCE_DIR}/genhelp.json ${CMAKE_CURRENT_BINARY_DIR}/bllnhlp.c
)

add_custom_target(balloonhelp ALL
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/bllnhlp.c
)

add_custom_command(
 	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/messages.h ${CMAKE_CURRENT_BINARY_DIR}/messages.but
	DEPENDS genmessages ${CMAKE_CURRENT_SOURCE_DIR}/messages.in
 	COMMAND genmessages ${GENMESSAGES_OPTS} ${CMAKE_CURRENT_SOURCE_DIR}/messages.in ${CMAKE_CURRENT_BINARY_DIR}/messages.but
)

add_custom_target(msgfiles ALL
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/messages.h ${CMAKE_CURRENT_BINARY_DIR}/messages.but
)

install(
	FILES xtrkcad.tip
	DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
)

set_target_properties(
	msgfiles
	balloonhelp
	genmessages
	genhelp
    PROPERTIES FOLDER HelpDocs
)

=== app/i18n/CMakeLists.txt ===
#
# handle translation using gettext
#
project(i18n)

# List of the supported locales.
set(xtrkcad_locale_ids
	cy_GB
	de_DE
	fi
	fr_FR
	pt_BR
	ru
	)

# Misc variables
set(xtc_locale_targets)
set(potfile "${i18n_BINARY_DIR}/${XTRKCAD_PACKAGE}.pot")
set(xgtkeywords
	--keyword=_
	--keyword=p_
	--keyword=N_
)

#
# Find programs, registry is used on Windows to find the installation path

find_program(xtc_xgettext xgettext PATHS [HKEY_LOCAL_MACHINE\\SOFTWARE\\GnuWin32\\;InstallPath]/bin )
find_program(xtc_msginit msginit PATHS [HKEY_LOCAL_MACHINE\\SOFTWARE\\GnuWin32\\;InstallPath]/bin )
find_program(xtc_msgmerge msgmerge PATHS [HKEY_LOCAL_MACHINE\\SOFTWARE\\GnuWin32\\;InstallPath]/bin )
find_program(xtc_msgfmt msgfmt PATHS [HKEY_LOCAL_MACHINE\\SOFTWARE\\GnuWin32\\;InstallPath]/bin )
set(xtc_translator "" CACHE FILEPATH "Translator program for editing the .po files.")
mark_as_advanced(xtc_xgettext xtc_msginit xtc_msgmerge
                 xtc_msgfmt xtc_translator)

# 
# Extract the translatable strings from text files
#
# Custom string extractor utility
add_executable(stripmsg stripmsg.c)

# Create custom message files list
file(GLOB_RECURSE xtc_custom_msg_files
	${XTrkCAD_SOURCE_DIR}/*.xtq
	${XTrkCAD_SOURCE_DIR}/*.xtr
	${XTrkCAD_SOURCE_DIR}/*.tip)

# Extract translatable strings from custom message files to one temporary file
add_custom_target(
	custmsg
	COMMAND stripmsg ${xtc_custom_msg_files} > ${CMAKE_CURRENT_BINARY_DIR}/custmsg.h
	DEPENDS stripmsg ${xtc_custom_msg_files}
)

set_target_properties(
   stripmsg custmsg
   PROPERTIES FOLDER i18n
)

#
# Create the list of the original source files.

get_target_property(sourcefiles xtrkcad-lib SOURCES)
foreach( file ${sourcefiles})
	#
	# do not scan dependent objects / libraries for translatable strings
	string(FIND "${file}" "TARGET_OBJECTS:" result)
	if(result EQUAL -1)
	#
	# bllnhlp is generated in the build directory and has to be special cased
		string(COMPARE NOTEQUAL ${file} "bllnhlp.c" RESULT)
		if(RESULT)
			cmake_path(ABSOLUTE_PATH file BASE_DIRECTORY ${xtrkcad-lib_SOURCE_DIR} )
			cmake_path(RELATIVE_PATH file BASE_DIRECTORY ${i18n_SOURCE_DIR})
			list(APPEND xgt_source_files ${file})
		endif()
	endif()
endforeach()

#
# add file with translatable strings 
set(SOURCEFILES 
	"${xtrkcad-lib_SOURCE_DIR}/misc.c"
	"${wlib_SOURCE_DIR}/mswlib/mswmisc.c"
	"${messagefile_BINARY_DIR}/messages.h"
	"${CMAKE_CURRENT_BINARY_DIR}/custmsg.h"
	"${XTrkCAD_BINARY_DIR}/app/help/bllnhlp.c"
)

foreach( file ${SOURCEFILES})
	cmake_path(RELATIVE_PATH 
		file 
		BASE_DIRECTORY ${i18n_SOURCE_DIR}
	)
	list(APPEND xgt_source_files ${file})
endforeach()

# Extract strings and create xtrkcad.pot
add_custom_command(
	OUTPUT ${potfile}
	COMMAND ${xtc_xgettext} 
			${xgtkeywords} 
			--add-comments=i18n 
			-d ${GETTEXT_PACKAGE} 
			-F 
			-o ${potfile} 
			--from-code=ISO-8859-15 ${xgt_source_files}
	DEPENDS custmsg
	WORKING_DIRECTORY ${i18n_SOURCE_DIR}
)


#
# function to create and update the po-file for a locale

function(updatepofile locale)
	set(pofile ${i18n_SOURCE_DIR}/${locale}.po)
	set(mofile_dir ${i18n_BINARY_DIR}/${locale}/LC_MESSAGES)
	set(mofile ${mofile_dir}/${XTRKCAD_PACKAGE}.mo)

	# Merge .pot file changes to .po file
	add_custom_target(msgmerge-${locale} 
		COMMAND ${xtc_msgmerge} -U --backup=none ${pofile} ${potfile}
    	COMMAND ${xtc_msgfmt} -c -v -o ${mofile} ${pofile}
		DEPENDS messages ${pofile} 
	)

	# If new locale id was added, add .po file creation routine
	if(NOT EXISTS ${pofile})
		add_custom_command(
			OUTPUT ${pofile}
			COMMAND ${xtc_msginit} -l ${locale} -o ${pofile} -i ${potfile}
			DEPENDS ${potfile}
			)
	endif()

	file(MAKE_DIRECTORY ${mofile_dir})

	# If translator program was given, add target to edit .po files with it
	if(xtc_translator)
		add_custom_target(msgtranslate-${locale}
			COMMAND ${xtc_translator} ${pofile}
		)
	endif()
	
	# Compile .po file to binary format .mo file
	add_custom_command(
		OUTPUT ${mofile}
		COMMAND ${xtc_msgfmt} -c -v -o ${mofile} ${pofile}
		DEPENDS ${pofile}
	)

	# Install all .mo files
	install(
		FILES ${mofile}
		DESTINATION ${XTRKCAD_LOCALE_INSTALL_DIR}/${locale}/LC_MESSAGES
		)

    set_target_properties(
	    msgmerge-${locale} 
 	    PROPERTIES FOLDER i18n
    )

    set(xtc_locale_targets
		${xtc_locale_targets}
		${i18n_BINARY_DIR}/${localeid}/LC_MESSAGES/xtrkcad.mo
		PARENT_SCOPE
   	)	
endfunction()

#
# Loop through the list of the supported locales

foreach(localeid ${xtrkcad_locale_ids})
   updatepofile(${localeid})   
endforeach(localeid)


# xTrackCAD must be built before this to
# make sure that the dynamically generated files messages.h and bllnhlp.c are
# up to date.
add_custom_target(messages 
	DEPENDS xtrkcad ${potfile}
)

set_target_properties(
   messages
   PROPERTIES FOLDER i18n
)

# Utility target for building all translations 
add_custom_target(alltranslations ALL
	DEPENDS ${xtc_locale_targets}
)

=== app/lib/CMakeLists.txt ===
# CMakeList for the LIB directory
#
# Include the subdirectories for params, examples and params
# Generate and install a Readme.txt file from markdown if pandoc is available on the system
# install desktop integration following freedesktop.org specification 
#
project(lib)

add_subdirectory(params)

install(FILES 
	COPYING
	logo.bmp
	xtrkcad.xtq
	xtrkcad.upd
	DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
	)

# install parameter files 
install(DIRECTORY params
		DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
		FILES_MATCHING
		PATTERN "*.xtp")

# install demos 
install(DIRECTORY demos 
		DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
		FILES_MATCHING
		PATTERN "*.xtr")

# install example layouts		
install(DIRECTORY examples
		DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
		FILES_MATCHING
		PATTERN "*.xtc")
		
# install release documentation Readme and CHANGELOG
# depends on pandoc
#
set( infile "${CMAKE_CURRENT_SOURCE_DIR}/Readme.md" )
set( outfile "${CMAKE_CURRENT_BINARY_DIR}/Readme.txt" )
set( changelogin "${CMAKE_CURRENT_SOURCE_DIR}/CHANGELOG.md" )
set( changelogout "${CMAKE_CURRENT_BINARY_DIR}/CHANGELOG.txt" )

if(PANDOC_FOUND)
	add_custom_command(OUTPUT "${outfile}"
					   COMMAND ${PANDOC_EXECUTABLE} "--from=Markdown" "--to=plain" "-o" ${outfile} ${infile} 
					   DEPENDS "${infile}" 
					  )
	add_custom_target(CHANGELOG ALL DEPENDS ${changelogout})					  
	add_custom_command(OUTPUT "${changelogout}"
					   COMMAND ${PANDOC_EXECUTABLE} "--from=Markdown" "--to=plain" "-o" ${changelogout} ${changelogin} 
					   DEPENDS "${changelogin}" 
					  )
	add_custom_target(Readme ALL DEPENDS ${outfile})
	install(FILES ${outfile} ${changelogout}
			DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
			)
else()			
	message(STATUS "Pandoc is not available on this system, Readme.txt and CHANGELOG.txt are not generated!")
endif()
	
if(UNIX AND NOT APPLE)
    install(PROGRAMS
        xdg-open xtrkcad-setup
        DESTINATION ${XTRKCAD_SHARE_INSTALL_DIR}
        )
	install(FILES
		xtrkcad${XTRKCAD_BETA}.desktop
		DESTINATION "${XTRKCAD_SHARE_INSTALL_DIR}/applications"
		RENAME xtrkcad.desktop
		)
	install(FILES
		xtrkcad.xml
		DESTINATION "${XTRKCAD_SHARE_INSTALL_DIR}/applications"
		)
	install(FILES
		xtrkcad.png
		DESTINATION "${XTRKCAD_SHARE_INSTALL_DIR}/pixmaps"
		)
endif()

=== app/tools/CMakeLists.txt ===

add_executable(listxtp listxtp.c)
set_target_properties(listxtp PROPERTIES FOLDER "Param Files")

if (WIN32)
	target_sources(listxtp PRIVATE dirent.c )
endif ()

add_subdirectory(halibut)
add_subdirectory(pngtoxpm)

=== distribution/posix/CMakeLists.txt ===
# Setup packaging ...
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "XTrackCAD is a CAD program for designing model railroad layouts.")
set(CPACK_GENERATOR "DEB" "RPM" "STGZ")
set(CPACK_SOURCE_GENERATOR "TGZ" "TBZ2" "ZIP")
set(CPACK_PACKAGE_RELEASE 1)
set(CPACK_RPM_PACKAGE_LICENSE "GPL")
set(CPACK_RPM_PACKAGE_GROUP "Applications/Engineering")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}////xtrkcad-desc.txt")
set(CPACK_PACKAGE_FILE_NAME "xtrkcad-setup-${XTRKCAD_VERSION}-${CPACK_PACKAGE_RELEASE}.${CMAKE_SYSTEM_PROCESSOR}")

if(XTRKCAD_BETA MATCHES "-beta")
	set(CPACK_INSTALL_PREFIX "/usr/local" )
else()
	set(CPACK_INSTALL_PREFIX "/usr" )
	set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "${CMAKE_CURRENT_SOURCE_DIR}/postinst;${CMAKE_CURRENT_SOURCE_DIR}/prerm")
endif()

set(CPACK_PACKAGING_INSTALL_PREFIX ${CPACK_INSTALL_PREFIX})

# get the specific configuration for each packager
set(CPACK_PROJECT_CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/package.txt)

set(CPACK_PACKAGE_VENDOR "XTrackCAD Fork Project")

# common dependencies for all Linux builds
set(CPACK_RPM_PACKAGE_REQUIRES "glibc gtk2 zlib")

set(CPACK_RPM_BUILDREQUIRES 
    "gcc, cmake >= 2.4.7, pkgconfig, gtk2-devel" 
    "gettext, gettext-devel, glibc-devel"
)

# Add dependency to webkitgtk if configured
if(NOT XTRKCAD_USE_BROWSER)
    set(CPACK_RPM_PACKAGE_REQUIRES 
        "${CPACK_RPM_PACKAGE_REQUIRES} webkitgtk")
#    message(AUTHOR_WARNING "Add dependency to webkitgtk for viewing help!")
endif()

#Add dependency to MiniXML (mxml) if configured
if(XTRKCAD_CREATE_SVG)
	set(CPACK_RPM_PACKAGE_REQUIRES
		"${CPACK_RPM_PACKAGE_REQUIRES} mxml")
endif()		

# exclude these directories from the rpm
set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION
	"/usr/local"
	"/usr/local/share"
	"/usr/local/bin" 
	"/usr/share/locale"
	"/usr/share/locale/*"
	"/usr/local/share/locale"
	"/usr/local/share/locale/*"
	"/usr/share/applications"
	"/usr/share/pixmaps"
)

set(CPACK_RPM_CHANGELOG_FILE "${CMAKE_CURRENT_SOURCE_DIR}////changelog.txt")

set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)

set(CPACK_DEBIAN_PACKAGE_NAME "XTrkCad${XTRKCAD_BETA}")

set(CPACK_DEBIAN_PACKAGE_VERSION "1:${XTRKCAD_VERSION}")

set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")

set(CPACK_DEBIAN_PACKAGE_DEPENDS "xdg-utils")

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "xtrkcad@sillub.com")

set(CPACK_PACKAGE_CONTACT "xtrkcad@sillub.com")

set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "XTrkCad supports any scale, has libraries of popular brands of \
turnouts and sectional track (plus you add your own easily), can \
automatically use spiral transition curves when joining track \
XTrkCad lets you manipulate track much like you would with actual \
flex-track to modify, extend and join tracks and turnouts. \
Additional features include tunnels, 'post-it' notes, on-screen \
ruler, parts list, 99 drawing layers, undo/redo commands, \
benchwork, 'Print to BitMap', elevations, train simulation and \
car inventory. \
")


set(CPACK_DEBIAN_PACKAGE_SECTION "contrib/graphics")

set(CPACK_DEBIAN_PACKAGE_COMPRESSION "gzip")

set(CPACK_DEBIAN_PACKAGE_PRIORITY "optional")

set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "xtrkcad.org")

set(CPACK_PACKAGE_EXECUTABLES "xtrkcad;XTrkCad-5.2.1-Beta")

set(CPACK_CREATE_DESKTOP_LINKS "xtrkcad")

include(CPack)

=== app/bin/bitmaps/CMakeLists.txt ===
# Generate XPM bitmaps from SVG files

PROJECT(genbitmaps)

# Find the conversion tool 

find_package(Inkscape)

if( NOT Inkscape_FOUND )
	message( STATUS "Inkscape not found." )
else()
	message(STATUS "Inkscape is: ${Inkscape_EXECUTABLE}")
	message(STATUS "Export option is: ${Inkscape_EXPORT}")

	set (XPMS
		background benchwork bezier-line bezier-track block bottom box
		bridge building car-inventory change-grid circle-center
		circle-filled-center circle-filled-tangent circle-line-center
		circle-line-tangent circle-line circle-tangent circle clone
		connect control convert-from convert-to copy cornu curved-chord
		curved-end curved-line-chord curved-line-end curved-line-middle
		curved-line-tangent curved-middle curved-tangent cut delete
		describe description dimension doc-export-bmap doc-export-dxf
		doc-export-svg doc-export doc-import-mod doc-import doc-new doc-open 
		doc-print doc-recent doc-revert doc-save-as doc-save doc-setup down 
		ease-broad ease-cornu ease-gt-broad ease-gt-sharp ease-lt-broad 
		ease-lt-sharp ease-none ease-normal ease-sharp
		elevation exit extend filled-box filled-polygon go helix
		info join-line join layers magnet manage map move
		new-car ok pan-zoom parallel-line parallel parameter paste
		polygon polyline profile protractor redo reflect roadbed
		rotate ruler select sensor signal snap-curs snap-grid
		split-draw split sticky-doc sticky-link sticky-note stop
		straight-line straight switch-motor table-edge text ties top
		train trim tunnel turnout-design turnout turntable undo
		zoom-choose zoom-extent zoom-in zoom-out
	)
	set( PIXS 16 24 32 )

	foreach(xpm ${XPMS})
		foreach(pix ${PIXS})
			if ( EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/png/${xpm}${pix}.png" )
				# MESSAGE( STATUS "Custom ${CMAKE_CURRENT_SOURCE_DIR}/png/${xpm}${pix}.png" )
				add_custom_command(
					OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/png/${xpm}${pix}.png
					DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/png/${xpm}${pix}.png
					COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/png/
					COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/png/${xpm}${pix}.png ${CMAKE_CURRENT_BINARY_DIR}/png/${xpm}${pix}.png
				)
			else()
				# MESSAGE( STATUS "SVG ${CMAKE_CURRENT_SOURCE_DIR}/svg/${xpm}.svg" )
				add_custom_command(
					OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/png/${xpm}${pix}.png
					DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/svg/${xpm}.svg
					COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/png/
					COMMAND ${Inkscape_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/svg/${xpm}.svg -h ${pix} ${Inkscape_EXPORT}${CMAKE_CURRENT_BINARY_DIR}/png/${xpm}${pix}.png
				)
			endif()
			# build a list of all the depends
			list(APPEND PNG_RESULTS ${CMAKE_CURRENT_BINARY_DIR}/png/${xpm}${pix}.png)
		endforeach()
		add_custom_command(
			OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${xpm}.xpm3
			DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/png/${xpm}16.png
			DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/png/${xpm}24.png
			DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/png/${xpm}32.png
			COMMAND pngtoxpm ${CMAKE_CURRENT_BINARY_DIR}/${xpm}.xpm3	
#			COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/${xpm}.xpm3 ${CMAKE_CURRENT_SOURCE_DIR}/${xpm}.xpm3 
		)
		# build a list of all the depends
		list(APPEND XPM_RESULTS ${xpm}.xpm3)
	endforeach()

	add_custom_target (
		genbitmaps 
		DEPENDS ${XPM_RESULTS}
		DEPENDS ${PNG_RESULTS}
	)
	
	if(WIN32)
		# Temporarily the FreeImage dll is copied to the build directory
		add_custom_command(
			TARGET genbitmaps PRE_BUILD
			COMMAND ${CMAKE_COMMAND} -E copy ${FREEIMAGE_SHAREDLIB} ${CMAKE_CURRENT_BINARY_DIR}
		)
		cmake_path(GET FREEIMAGE_SHAREDLIB FILENAME filename)
		add_custom_command(
			TARGET genbitmaps POST_BUILD
			COMMAND ${CMAKE_COMMAND} -E rm ${CMAKE_CURRENT_BINARY_DIR}/${filename}
		)
#

	endif()
endif()

#MESSAGE (STATUS "SVG Converter: ${SVG_CONVERTER}")
#MESSAGE (STATUS "Source Dir: ${CMAKE_CURRENT_SOURCE_DIR}")
#MESSAGE (STATUS "XPMs: ${XPMS}")
#MESSAGE (STATUS "XPM_RESULTS: ${XPM_RESULTS}")
#MESSAGE (STATUS "PNG_RESULTS: ${PNG_RESULTS}")

=== debian/changelog ===
xtrkcad (1:5.3.0GA-1.1build1) plucky; urgency=medium

  * Rebuild against latest libzip

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 22 Nov 2024 08:56:25 -0500

xtrkcad (1:5.3.0GA-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Reintroduce changes from 1:5.2.0Beta2.1-2 accidentally dropped by the
    last upload. (Closes: #1087529, #1066691)
  * Delete precompiled libzip.a via d/clean (Closes: #1087474)

 -- Tobias Frost <tobi@debian.org>  Thu, 14 Nov 2024 20:36:25 +0100

xtrkcad (1:5.3.0GA-1) unstable; urgency=medium

  * New upstream release (Closes: #1057286, #1074722):
  * debian/control:
    - Add Build-Depends:
      + inkscape
      + libfreeimage-dev
      + pandoc
    - Change to new repository URL.
    - Change Standards-Version to 4.7.0.0 (No changes needed).
    - Add myself as Maintainer and Daniel E. Markle as Uploader.
      (Closes: #1057287)
  * debian/xtrkcad.install:
    - Add CHANGELOG.txt, Readme.txt
  * debian/copyright:
    - Add year 2024 to myself.
    - Rebase for the new release.
  * debian/changlog:
    - Remove trailing whitespace.
  * debian/rules:
    - Remove trailing whitespace.

 -- Jörg Frings-Fürst <debian@jff.email>  Wed, 03 Jul 2024 21:32:38 +0200

=== debian/control ===
Source: xtrkcad
Section: editors
Priority: optional
Maintainer: Jörg Frings-Fürst <debian@jff.email>
Uploaders:
 Daniel E. Markle <dmarkle@ashtech.net>,
 Mike Gabriel <sunweaver@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 inkscape,
 libfreeimage-dev,
 libgtk2.0-dev,
 libzip-dev,
 pandoc
Rules-Requires-Root: no
Standards-Version: 4.7.0.0
Homepage: http://xtrkcad.org/
Vcs-Git: git://git.jff.email/xtrkcad.git
Vcs-Browser: https://git.jff.email/cgit/xtrkcad.git

Package: xtrkcad
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 xtrkcad-common (= ${source:Version})
Description: CAD program for designing model railroad layouts
 With XTrackCAD you can:
  Design layouts in any scale and gauge
  Use the predefined libraries for many popular brands of turnouts to
  help you get started easily
  Add your own favorite components
  Manipulate track much like you would with actual flex-track to modify
  extend and join tracks and turnouts
  Test your design by running trains, including picking them up and moving
  them with the mouse.
  At any point you can print the design in a scale of your choice. When
  printed in 1:1 scale the printout can be used as a template for laying
  the track to build your dream layout.
  Learning XTrackCAD is made easy with the extensive on-line help and
  demonstrations.

Package: xtrkcad-common
Architecture: all
Depends:
 ${misc:Depends}
Breaks:
 xtrkcad (<< 1:4.2.4a-1)
Replaces:
 xtrkcad (<< 1:4.2.4a-1)
Description: CAD program for designing model railroad layouts (common files)
 With XTrackCAD you can:
  Design layouts in any scale and gauge
  Use the predefined libraries for many popular brands of turnouts to
  help you get started easily
  Add your own favorite components
  Manipulate track much like you would with actual flex-track to modify
  extend and join tracks and turnouts
  Test your design by running trains, including picking them up and moving
  them with the mouse.
  At any point you can print the design in a scale of your choice. When
  printed in 1:1 scale the printout can be used as a template for laying
  the track to build your dream layout.
  Learning XTrackCAD is made easy with the extensive on-line help and
  demonstrations.
 .
 This package contains the demo, examples, parameter and the help files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND =  -Wl,--allow-multiple-definition

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
			-DXTRKCAD_USE_GETTEXT=ON \
			-DXTRKCAD_USE_GTK=ON \
			-DCMAKE_INSTALL_PREFIX:PATH=/usr/

## xtrkcad 5.3.1GA

=== CMakeLists.txt ===
--- 
+++ 
@@ -48,8 +48,13 @@
 # Find document conversion tool
 find_package(Pandoc)
 
-# For handling and creation of bitmaps the FreeImage library is required
-find_package(FreeImage REQUIRED)
+# Flatpak
+find_package(Flatpak)
+
+# For handling and creation of bitmaps the FreeImage library is required on Windows
+if(WIN32)
+	find_package(FreeImage REQUIRED)
+endif()
 
 # check for GTK+ 2.0
 if(UNIX)

=== app/CMakeLists.txt ===




# Setup the rest of the build ...
add_subdirectory(tools)
add_subdirectory(help)
add_subdirectory(bin)
add_subdirectory(cornu)
add_subdirectory(dynstring)
add_subdirectory(cJSON)
add_subdirectory(wlib)
add_subdirectory(doc)
add_subdirectory(lib)

# i18n can be found here
include_directories(
	${xtrkcad-lib_SOURCE_DIR}
)

if(XTRKCAD_USE_GETTEXT)
	add_subdirectory(i18n)
endif()

=== distribution/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,9 @@
 
 IF(UNIX AND NOT APPLE)
 	ADD_SUBDIRECTORY(posix)
+    if(Flatpak_FOUND)
+	    ADD_SUBDIRECTORY(flatpak)
+    endif()
 ENDIF(UNIX AND NOT APPLE)
 
 IF(WIN32)

=== app/bin/CMakeLists.txt ===
--- 
+++ 
@@ -168,6 +168,7 @@
     layout.h
     levenshtein.c
     linknoteui.c
+    locale.c
     lprintf.c
     macro.c
     manifest.c
@@ -213,6 +214,7 @@
 	trkseg.h
     trkseg.c
     tstraigh.c
+    toolbar.c
     turnout.c
     uthash.h
     utility.c
@@ -268,10 +270,14 @@
     target_link_libraries(xtrkcad-lib 
         PRIVATE 
         Libzip::Libzip 
-        FreeImage::FreeImage 
         Zlib::Zlib)
 endif()
 
+if(WIN32)
+    target_link_libraries(xtrkcad-lib 
+        PRIVATE 
+        FreeImage::FreeImage)
+endif()
 #
 # Start building the main program itself
 #

=== app/cJSON/CMakeLists.txt ===
#
# build the cJSON object library

add_library( cJSON  "")

target_sources(cJSON
	PRIVATE
		cJSON.c
	PUBLIC
		cJSON.h
)

target_include_directories(cJSON PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== app/dynstring/CMakeLists.txt ===
# compile the dynstring library

add_library(dynstring
			"")

target_sources(dynstring
	PRIVATE
		dynstring.c
	PUBLIC 
		dynstring.h
)			

if(XTRKCAD_TESTING)			
	add_subdirectory(unittest)
endif()    

target_include_directories(dynstring PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")

=== app/i18n/CMakeLists.txt ===
--- 
+++ 
@@ -134,8 +134,7 @@
 			)
 	endif()
 
-	file(MAKE_DIRECTORY ${mofile_dir})
-
+	file(MAKE_DIRECTORY ${mofile_dir} )
 	# If translator program was given, add target to edit .po files with it
 	if(xtc_translator)
 		add_custom_target(msgtranslate-${locale}

=== app/lib/CMakeLists.txt ===
--- 
+++ 
@@ -68,7 +68,6 @@
 	install(FILES
 		xtrkcad${XTRKCAD_BETA}.desktop
 		DESTINATION "${XTRKCAD_SHARE_INSTALL_DIR}/applications"
-		RENAME xtrkcad.desktop
 		)
 	install(FILES
 		xtrkcad.xml

=== app/tools/CMakeLists.txt ===
--- 
+++ 
@@ -7,4 +7,6 @@
 endif ()
 
 add_subdirectory(halibut)
+if ( WIN32 )
 add_subdirectory(pngtoxpm)
+endif()

=== app/wlib/CMakeLists.txt ===
project(wlib)

add_library( xtrkcad-wlib
			"")		

add_subdirectory(include)

# add i18n.h to include path
target_include_directories(xtrkcad-wlib 
	PRIVATE 
	${xtrkcad-lib_SOURCE_DIR}
)

if(XTRKCAD_USE_GTK)
	add_subdirectory(gtklib)
else()
	add_subdirectory(mswlib)
endif()

=== distribution/flatpak/CMakeLists.txt ===
set(FLATPAK_BUILD_SCRIPT "${CMAKE_SOURCE_DIR}/distribution/flatpak/buildFlatpak.sh")
set(FLATPAK_FILE ${CMAKE_BINARY_DIR}/xtrkcad-${XTRKCAD_VERSION}.flatpak)

add_custom_command(
    OUTPUT ${FLATPAK_FILE}
    COMMAND ${FLATPAK_BUILD_SCRIPT} ${CMAKE_BINARY_DIR}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMENT "Re-compiling xtrkcad within flatpak Sdk; this could take a while ..."
    DEPENDS ${FLATPAK_BUILD_SCRIPT}
)

# makes for an easy target: "make flatpak" or "ninja flatpak"
add_custom_command(
    OUTPUT flatpak
    COMMAND ${FLATPAK_BUILD_SCRIPT} ${CMAKE_BINARY_DIR}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMENT "Re-compiling xtrkcad within flatpak Sdk; this could take a while ..."
    DEPENDS ${FLATPAK_BUILD_SCRIPT}
)

add_custom_target(flatpak
    DEPENDS ${FLATPAK_FILE}
    COMMENT "Generating xtrkcad-${XTRKCAD_VERSION}.flatpak"
)

=== distribution/osx/CMakeLists.txt ===
# Automatically generate most of our external dependencies ...
SET(XTRKCAD_LOCATION $<TARGET_FILE:xtrkcad>)
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/dependencies.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/dependencies.cmake" @ONLY)
INSTALL(SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/dependencies.cmake")


# Generate bundles ...
ADD_SUBDIRECTORY(bundle)

# Add replacement bundle technique ...
FILE(COPY gtk-bundle/ DESTINATION gtk-bundle )

ADD_SUBDIRECTORY(gtk-bundle)

=== debian/changelog ===
xtrkcad (1:5.3.1GA-1) unstable; urgency=medium

  * debian/rules:
    - Add -std=gnu17 to CFLAGS to fix FTBFS with GCC-15 (Closes: #1098175).
  * debian/copyright:
    - Replace old FSF address.
    - Rewrite to make lrc happy.
  * debian/control:
    - Bump Standards-Version to 4.7.2.0.
    - Change Vcs-Git from git to https.
  * debian/patches/0005-fix_link_lib_failed.patch:
    - Fix Last-Update
  * overrides:
    - Remove now useless debian/source/lintian-overrides.
    - Remove source-is-missing from debian/xtrkcad-common.lintian-overrides.

 -- Jörg Frings-Fürst <debian@jff.email>  Sun, 26 Oct 2025 18:04:34 +0100

=== debian/control ===
--- 
+++ 
@@ -14,9 +14,9 @@
  libzip-dev,
  pandoc
 Rules-Requires-Root: no
-Standards-Version: 4.7.0.0
+Standards-Version: 4.7.2.0
 Homepage: http://xtrkcad.org/
-Vcs-Git: git://git.jff.email/xtrkcad.git
+Vcs-Git: https://git.jff.email/cgit/xtrkcad.git
 Vcs-Browser: https://git.jff.email/cgit/xtrkcad.git
 
 Package: xtrkcad

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 # hardening
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND =  -Wl,--allow-multiple-definition
+export CFLAGS = $(shell dpkg-buildflags --get CFLAGS) -std=gnu17
+
 
 %:
 	dh $@
